/*
 * Copyright (c) 2001 Michael David Adams.
 * All rights reserved.
 *
 * The complete licensing terms for this software can be found in the file
 * named "LICENSE" in this software distribution.
 */

/******************************************************************************\
* Includes.
\******************************************************************************/

#include "image.h"

/******************************************************************************\
* Code.
\******************************************************************************/

/* Initialize the image format table. */
void image_initfmts()
{
	image_fmtops_t fmtops;
	int fmtid;

	fmtid = 0;

#if !defined(EXCLUDE_MIF_SUPPORT)
	fmtops.load = image_load_mif;
	fmtops.save = image_save_mif;
	fmtops.validate = mif_validate;
	image_addfmt(fmtid, "mif", "mif", &fmtops);
	++fmtid;
#endif

#if !defined(EXCLUDE_PNM_SUPPORT)
	fmtops.load = image_load_pnm;
	fmtops.save = image_save_pnm;
	fmtops.validate = pnm_validate;
	image_addfmt(fmtid, "pnm", "pnm", &fmtops);
	image_addfmt(fmtid, "pnm", "pgm", &fmtops);
	image_addfmt(fmtid, "pnm", "ppm", &fmtops);
	++fmtid;
#endif

#if !defined(EXCLUDE_BMP_SUPPORT)
	fmtops.load = image_load_bmp;
	fmtops.save = image_save_bmp;
	fmtops.validate = bmp_validate;
	image_addfmt(fmtid, "bmp", "bmp", &fmtops);
	++fmtid;
#endif

#if !defined(EXCLUDE_RAS_SUPPORT)
	fmtops.load = image_load_ras;
	fmtops.save = image_save_ras;
	fmtops.validate = ras_validate;
	image_addfmt(fmtid, "ras", "ras", &fmtops);
	++fmtid;
#endif

#if !defined(EXCLUDE_JP2_SUPPORT)
	fmtops.load = image_load_jp2;
	fmtops.save = image_save_jp2;
	fmtops.validate = jp2_validate;
	image_addfmt(fmtid, "jp2", "jp2", &fmtops);
	++fmtid;
	fmtops.load = image_load_jpc;
	fmtops.save = image_save_jpc;
	fmtops.validate = jpc_validate;
	image_addfmt(fmtid, "jpc", "jpc", &fmtops);
	++fmtid;
#endif

}
