/*
 * Copyright (c) 1999-2000 Image Power, Inc. and the University of
 *   British Columbia.
 * Copyright (c) 2001 Michael David Adams.
 * All rights reserved.
 *
 * The complete licensing terms for this software can be found in the file
 * named "LICENSE" in this software distribution.
 */

/*
 * String Library
 *
 * $Id$
 */

/******************************************************************************\
* Includes
\******************************************************************************/

#include <string.h>
#include <stdlib.h>

#include "memalloc.h"
#include "stringx.h"

/******************************************************************************\
* Miscellaneous Functions
\******************************************************************************/

/* This function is equivalent to the popular but non-standard strdup
  function. */
/* Although I could have called this function strdup, and then wrapped
  it in a conditional compile, I have not done so for a number of
  logistical reasons. :-) */
char *strclone(const char *s)
{
	int n;
	char *p;
	n = strlen(s) + 1;
	if (!(p = malloc(n * sizeof(char)))) {
		return 0;
	}
	strcpy(p, s);
	return p;
}
