/*
 * Copyright (c) 1999-2000 Image Power, Inc. and the University of
 *   British Columbia.
 * Copyright (c) 2001 Michael David Adams.
 * All rights reserved.
 *
 * The complete licensing terms for this software can be found in the file
 * named "LICENSE" in this software distribution.
 */

/*
 * Command Line Option Parsing Library
 *
 * $Id$
 */

#ifndef GETOPTX_H
#define GETOPTX_H

#ifdef __cplusplus
extern "C" {
#endif

/******************************************************************************\
* Constants.
\******************************************************************************/

#define	GETOPT_EOF	(-1)
#define	GETOPT_ERR	'?'

/* option flags. */
#define	OPT_HASARG	0x01	/* option has argument */

/******************************************************************************\
* Types.
\******************************************************************************/

typedef struct {

	int id;
	/* The unique identifier for this option. */

	char *name;
	/* The name of this option. */

	int flags;
	/* option flags. */

} opt_t;

/******************************************************************************\
* External data.
\******************************************************************************/

/* These variables are for internal use by the option parsing code. */
extern int optind;
extern char *optarg;
extern int opterr;

/******************************************************************************\
* Prototypes.
\******************************************************************************/

/* Get the next option. */
int getoptx(int argc, char **argv, opt_t *opts);

#ifdef __cplusplus
}
#endif

#endif
