/*
 * Copyright (c) 1999-2000 Image Power, Inc. and the University of
 *   British Columbia.
 * Copyright (c) 2001 Michael David Adams.
 * All rights reserved.
 *
 * The complete licensing terms for this software can be found in the file
 * named "LICENSE" in this software distribution.
 */

/*
 * Math Library
 *
 * $Id$
 */

#ifndef	MATHX_H
#define	MATHX_H

#ifdef __cplusplus
extern "C" {
#endif

/******************************************************************************\
* Includes
\******************************************************************************/

#include	<assert.h>
#include	<stdio.h>
#include	<string.h>

/******************************************************************************\
* Macros
\******************************************************************************/

#ifndef	min
#define	min(x, y)	(((x) < (y)) ? (x) : (y))
#endif
#ifndef	max
#define	max(x, y)	(((x) > (y)) ? (x) : (y))
#endif

#define	mod(x, y) \
	(((x) < 0) ? (((-x) % (y)) ? ((y) - ((-(x)) % (y))) : (0)) : ((x) % (y)))

/******************************************************************************\
* Function Prototypes
\******************************************************************************/

double pow2i(int n);
int firstone(int x);
int ceillog2(int x);
int floorlog2(int x);

#define	DIVFLOOR(x, y)	(assert(x >= 0 && y > 0), (x) / (y))
#define	DIVCEIL(x, y)	(assert(x >= 0 && y > 0), ((x) + (y) - 1) / (y))

#define	DIVPOW2FLOOR(x, y) \
	(assert(x >= 0 && y > 0), (x) >> (y))
#define	DIVPOW2CEIL(x, y) \
	(assert(x >= 0 && y >= 0), ((x) + (1 << (y)) - 1) >> (y))

#define	ONES(n) \
  (((n) < 32) ? ((1 << (n)) - 1) : (0xffffffff))

#ifdef __cplusplus
}
#endif

#endif
