/*
 * Copyright (c) 1999-2000 Image Power, Inc. and the University of
 *   British Columbia.
 * Copyright (c) 2001 Michael David Adams.
 * All rights reserved.
 *
 * The complete licensing terms for this software can be found in the file
 * named "LICENSE" in this software distribution.
 */

/*
 * $Id$
 */

#ifndef	UTIL_H
#define	UTIL_H

#ifdef __cplusplus
extern "C" {
#endif

/******************************************************************************\
* Includes
\******************************************************************************/

#include	<assert.h>
#include	<stdio.h>
#include	<string.h>

/******************************************************************************\
* Function Prototypes
\******************************************************************************/

int atoaf(char *s, int *numvalues, double **values);

void hexdump(FILE *out, unsigned char *data, int len);

int eprintf(const char *fmt, ...);

int getdbglevel();
int setdbglevel(int newdbglevel);

#if defined(DEBUG)
#define	LOGMSG(n, x) \
	((getdbglevel() >= (n)) ? (eprintf x) : 0)
#else
#define	LOGMSG(n, x)
#endif

#ifdef __cplusplus
}
#endif

#endif
