/*
 * Copyright (c) 1999-2000 Image Power, Inc. and the University of
 *   British Columbia.
 * Copyright (c) 2001 Michael David Adams.
 * All rights reserved.
 *
 * The complete licensing terms for this software can be found in the file
 * named "LICENSE" in this software distribution.
 */

/*
 * MQ Arithmetic Coder
 *
 * $Id$
 */

#ifndef MQCOD_H
#define MQCOD_H

/******************************************************************************\
* Includes.
\******************************************************************************/

#include "types.h"
#include "stream.h"

/******************************************************************************\
* Types.
\******************************************************************************/

/*
 * Context information.
 */

typedef struct {

	bool mps;
	/* The most probable symbol (MPS). */

	int_fast16_t ind;
	/* The state index. */

} mqctx_t;

typedef struct mqstate_s {

	uint_fast16_t qeval;
	/* The Qe value. */

	uint_fast16_t mps;
	/* The MPS. */

	struct mqstate_s *nmps;
	/* The NMPS state. */

	struct mqstate_s *nlps;
	/* The NLPS state. */

} mqstate_t;

/******************************************************************************\
* Data.
\******************************************************************************/

/* The state table for the MQ coder. */
extern mqstate_t mqstates[];

#endif
